<template lang="pug">
.create
	template(v-if="modalVisible")
		.modal(@click="closeModal")
			.modal__container
				template(v-if="loading")
					loader
				template(v-else)
					.modal__header
						.modal__header-icon: i.fas.fa-plus
						.modal__header-title {{ humanizeMode }} candidate

					template(v-if="step === 1")
						form.modal__content(data-vv-scope="candidateForm")
							.create__row.create__row--double
								.create__input
									label Name
									div(:class="{ 'error': errors.has('candidateForm.name') }")
										span.error__message {{ errors.first('candidateForm.name')}}
										input(v-focus="" v-model.trim="form.name" v-validate="'required|max:20'" name="name" placeholder="Name" autocomplete="off")

								.create__input
									label Last name
									div(:class="{ 'error': errors.has('candidateForm.last_name') }")
										span.error__message {{ errors.first('candidateForm.last_name')}}
										input(v-model.trim="form.last_name" v-validate="'required|max:20'" name="last_name" placeholder="Last name" autocomplete="off")

							.create__row
								.create__input
									label Phone
									div(:class="{ 'error': errors.has('candidateForm.phone') }")
										span.error__message {{ errors.first('candidateForm.phone')}}
										input(v-model.trim="form.phone" v-validate="'required|max:20|numeric'" name="phone" placeholder="Phone number" autocomplete="off")

							.create__row
								.create__input
									label Address
									div(:class="{ 'error': errors.has('candidateForm.address') }")
										span.error__message {{ errors.first('candidateForm.address')}}
										input(v-model.trim="form.address" v-validate="'required|max:50'" name="address" placeholder="Address" autocomplete="off")

						.modal__footer(right)
							.button.button--default(@click="onChangeStep(2)") #[i.fas.fa-long-arrow-alt-right] laboral reference

					template(v-if="step === 2")
						form.modal__content(data-vv-scope="laboralForm")
							.create__row
								.create__input
									label Company name
									div(:class="{ 'error': errors.has('laboralForm.company') }")
										span.error__message {{ errors.first('laboralForm.company')}}
										input(v-model.trim="laboralReference.company" v-validate="'required|max:50'" name="company" placeholder="Address" autocomplete="off")

							.create__row
								.create__input
									label Contact name
									div(:class="{ 'error': errors.has('laboralForm.contact') }")
										span.error__message {{ errors.first('laboralForm.contact')}}
										input(v-model.trim="laboralReference.contact" v-validate="'required|max:50'" name="contact" placeholder="Address" autocomplete="off")

							.create__row.create__row--double
								.create__input
									label Start at
									div(:class="{ 'error': errors.has('laboralForm.start') }")
										span.error__message {{ errors.first('laboralForm.start')}}
										datepicker.create__calendar(v-model="laboralReference.start" v-validate="'required'" name="start" calendar-class="calendar" placeholder="Start at")

								.create__input
									label Leave at
									div(:class="{ 'error': errors.has('laboralForm.leave') }")
										span.error__message {{ errors.first('laboralForm.leave')}}
										datepicker.create__calendar(v-model="laboralReference.leave" v-validate="" name="leave" calendar-class="calendar" placeholder="Leave at")

							.create__row
								.link.link--default(@click="onAddLaboralReference") #[i.fas.fa-plus] add laboral reference

							.create__references-container
								.create__references-item(v-for="reference in form.laboral_references")
									i.create__references-item-avatar.fas.fa-briefcase
									.create__references-item-wrapper
										.create__references-item-company {{ reference.company }}
										.create__references-item-contact {{ reference.contact }}
										.create__references-item-footer
											.create__references-item-start Start at {{ $moment(reference.start).format('DD/MM/YYYY') }}
											.create__references-item-leave Leave at {{ $moment(reference.leave).format('DD/MM/YYYY') }}
									i.create__references-item-delete.fas.fa-trash(@click="onRemoveReference(reference)")


						.modal__footer(right)
							.link(@click="onChangeStep(1)") General information
							.button.button--default(@click="onSubmitForm")  #[i.fas.fa-save] {{ humanizeMode }} candidate
</template>



<script>
import { mapActions, mapGetters } from 'vuex'
import Datepicker from 'vuejs-datepicker'
import modal from '@/mixins/modal'
import Loader from '@/components/Loader'

export default {
	components: {
		Loader,
		Datepicker
	},

	data() {
		return {
			loading: false,

			step: 1,

			laboralReference: {
				company: '',
				contact: '',
				start: '',
				leave: '',
			},

			form: {
				name: '',
				last_name: '',
				phone: '',
				address: '',
				laboral_references: []
			}
		}
	},

	mixins: [
		modal
	],

	watch: {
		modalVisible(value) {
			if (!value) {
				this.resetState()
			}
		}
	},

	methods: {
		...mapActions('root', [
			'$handleCandidate'
		]),

		resetState() {
			this.step = 1

			this.laboralReference = {
				company: '',
				contact: '',
				start: '',
				leave: ''
			}

			this.form = {
				name: '',
				last_name: '',
				phone: '',
				address: '',
				laboral_references: []
			}
		},

		generateID() {
			let alpha = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789'
			let jumble = function() {
				let jumbleString = ''

				for (let i = 0; i < 8; i++) {
					jumbleString += alpha.charAt(Math.floor(Math.random() * alpha.length))
				}

				return jumbleString
			}

			return jumble()
		},

		onAddLaboralReference() {
			this.$validator.validateAll('laboralForm')
				.then(success => {
					if (!success) return

					let laboralReference = JSON.parse(JSON.stringify(this.laboralReference))

					laboralReference._id = this.generateID()
					this.form.laboral_references.push(laboralReference)
					
					this.$validator.pause()

					for (let field in this.laboralReference) {
						this.laboralReference[field] = ''
					}

					this.$nextTick(() => {
						this.$validator.resume()
					})
				})
		},

		onRemoveReference(data) {
			let references = this.form.laboral_references

			for (let r = 0; r < references.length; r++) {
				let reference = references[r]

				if (reference._id === data._id) {
					return references.splice(r, 1)
				}
			}
		},

		onChangeStep(step) {
			switch (step) {
				case 2:
					this.$validator.validateAll('candidateForm')
						.then(success => {
							if (success) this.step = step
						})
					break

				default:
					this.step = step
			}
		},

		onSubmitForm() {
			this.loading = true

			this.$handleCandidate({
					url: '/candidate',
					method: this.isEditMode ? 'put' : 'post',
					form: this.form,
					options: {
						...this.isEditMode && {
							params: {
								_id: this.form._id
							}
						}
					}
				})
				.then(data => {
					this.loading = false

					if (data.success) {
						this.resetState()
						return this.closeModal()
					}
				})
		}
	}
}
</script>



<style lang="scss" scoped>
.create {
    $this: &;

    &__calendar {
        @include calendar;
    }

    &__row {
        &:not(:last-of-type) {
            margin-bottom: 20px;
        }

        &--double {
            display: flex;

            #{$this}__input {
                flex: 1 1 auto;

                &:nth-of-type(1) {
                    margin-right: 12.5px;
                }

                &:nth-of-type(2) {
                    margin-left: 12.5px;
                }
            }
        }
    }

    &__references {
        margin-top: 50px;

        &-header {
            display: flex;
            justify-content: space-between;
            margin-bottom: 25px;
        }

        &-container {
            height: 250px;
            border: 1px solid $gray;
            border-radius: 5px;
            margin-top: 25px;
            padding: 15px 25px;
            overflow-y: auto;
        }

        &-item {
            display: flex;
            padding: 15px 0;

            &-avatar {
                @include avatar;
            }

            &-company {
                font-size: 1.6rem;
                // line-height: 1;
                // margin-bottom: 2.5px;
            }

            &-contact {
                font-size: 1.4rem;
                margin-bottom: 5px;
                color: $gray;
            }

            &-footer {
                font-size: 1.2rem;
                color: $gray;
                display: flex;
            }

            &-start {
                margin-right: 25px;
            }

            &-delete {
                font-size: 1.2rem;
                color: $gray;
                margin-left: auto;
                align-self: center;

                &:hover {
                    color: $light_dark;
                    cursor: pointer;
                }
            }
        }
    }
}
</style>
